--scenario utilities
local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')
local Utilities = import('/lua/utilities.lua')
local endGameTime = 20 --end time in second before the reinforcement, here 20s !!
scnPrint = function(text,army,playeronly)
local colorIndex = ScenarioInfo.ArmySetup[army].PlayerColor
local color = import('/lua/GameColors.lua').GameColors.ArmyColors[colorIndex]
if not playeronly then
playerspecific = false
else
playerspecific = playeronly
end
if playerspecific == true then
if army == indexToArmy(GetFocusArmy()) then
PrintText(text,20,color,10,'center')
end
else
PrintText(text,20,color,10,'center')
end
end
--returns the username of the army
username = function(army)
return GetArmyBrain(army).Nickname
end
--*****************************************************************************
function OnPopulate()
ScenarioUtils.InitializeArmies()
initialiseAlliances()
end
--the defender is alone against the attackers
function initialiseAlliances()
for index,army in ListArmies() do
if army != 'ARMY_1' and army != 'ARMY_2' then
SetAlliance( 'ARMY_1', army, 'Enemy')
else
SetAlliance( 'ARMY_1', 'ARMY_2', 'Ally')
end
end
end
function OnStart(self)
--victory condition thread
local endThread = ForkThread(function(self)
WaitSeconds(endGameTime)
--defenderWin()
reinforcements()
KillThread(self)
end)
end
--defender wins
--all attackers lose
function defenderWin()
for index,army in ListArmies() do
if army == 'ARMY_1' then
GetArmyBrain('ARMY_1'):OnVictory()
else
GetArmyBrain(army):OnDefeat()
end
end
end
--final reinforcements for defender
function reinforcements()
scnPrint( username('ARMY_1') .. "reinforcements have arrived!",'ARMY_1',false)
local x = 50
local y = 50
local i = 0
local units = {}
while i < 400 do
local unit = false
if i < 200 then
unit = CreateUnitHPR( 'ura0401', 'ARMY_1', x+i,50,y, 0,0,0)
else
unit = CreateUnitHPR( 'ura0401', 'ARMY_2', x+i,50,y, 0,0,0)
end
table.insert(units,unit)
i = i + 10
IssueAttack( {unit}, {x+i,25,500} )
end
--IssueMove( units, {200,25,200} )
--spawn units
--issue orders
end
